#!/usr/bin/env python3

import jp4
#import cv2
import numpy as np
import sys
from PIL import Image, ImageOps

try:
  filename = sys.argv[1]
except IndexError:
  filename = "test.jp4"

img = jp4.JP4(filename)

# print exif
#print(img.exif.toString())

# deblock if JP4 (auto read from exif) skip if other
img.deblock()
img.demosaic_bilinear()
img.saturation()

I = img.image[...,[2,1,0]].astype(np.uint8)
res = Image.fromarray(I)
#res.save("result.png")
# also works
#res.save("result.jpeg")

# for Eyesis4pi

exif = img.exif
mn = exif.MakerNote

#print(exif.MakerNote)

# common
#    WOI_WIDTH
#    FLIPH
#    FLIPV
#    PORTRAIT
#    COMPOSITE
# individual
#    HEIGHTx, 1..3
#    FLIPHx, 1..3
#    FLIPVx, 1..3
#    BLANKx, only 1 and 2

if mn['COMPOSITE']:
  
  W = mn['WOI_WIDTH']
  H = mn['WOI_HEIGHT']
  FH = mn['FLIPH']
  FV = mn['FLIPV']
  
  #if FV:
  #  I = 
  
  v_offset = 0
  
  for i in range(1,4):
    
    try:
      height = mn['HEIGHT'+str(i)]
      #fliph  = mn['FLIPH'+str(i)]
      flipv  = mn['FLIPV'+str(i)]
    except KeyError:
      # break for '_9'
      break
    
    try:
      blank = mn['BLANK'+str(i)]
    except KeyError:
      blank = 0
    
    crop = res.crop((0,v_offset,W,v_offset+height))
    
    if flipv:
      crop = ImageOps.flip(crop)
      
    # if eyesis4pi, 1&2 - rotate 90CW, 3 - 90CCW
    if i<3:
      crop = crop.rotate(-90,expand=1)
    else:
      crop = crop.rotate(90,expand=1)
      
    crop.save("result_"+str(i)+".jpeg")
    
    v_offset += height + blank
